using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security.Cryptography;

namespace Toolkit
{
	/// <summary>
	/// AESȈÍB
	/// .NET̃Cu͌̐Ƃ₱̂ŊȒPɃbsOB
	/// </summary>
	public class AESCrypt
	{
		RijndaelManaged aes;
		/// <summary>
		/// B
		/// </summary>
		/// <param name="password">pX[h</param>
		public AESCrypt(string password) {
			aes = new RijndaelManaged();
			aes.Key = CryptUtility.MakeBytes(password, aes.KeySize);
			aes.IV = CryptUtility.MakeBytes(password, aes.BlockSize);
		}

		public byte[] EncodeString(string data) {
			return Encode(Encoding.Default.GetBytes(data));
		}
		public string DecodeString(byte[] data) {
			return Encoding.Default.GetString(Decode(data));
		}
		public byte[] Encode(byte[] data) {
			using (MemoryStream ms = new MemoryStream())
			using (CryptoStream cs = new CryptoStream(ms, aes.CreateEncryptor(), CryptoStreamMode.Write)) {
				cs.Write(data, 0, data.Length);
				cs.FlushFinalBlock();
				return ms.ToArray();
			}
		}
		public byte[] Decode(byte[] data) {
			using (MemoryStream ms = new MemoryStream())
			using (CryptoStream cs = new CryptoStream(ms, aes.CreateDecryptor(), CryptoStreamMode.Write)) {
				cs.Write(data, 0, data.Length);
				cs.FlushFinalBlock();
				return ms.ToArray();
			}
		}
	}

	/// <summary>
	/// Íp̃wp
	/// </summary>
	internal static class CryptUtility
	{
		public static byte[] MakeBytes(string password, int bitSize) {
			byte[] data = new byte[bitSize / 8];
			// pX[ĥ܂܎ĝ͉ƂȂsȂ̂ŃnbVƂB
			// cłg΂񂾂񂩂KB
			byte[] hash = new SHA512Managed().ComputeHash(
				Encoding.Default.GetBytes(password));
			// 傫ɍ킹āA]Ăxor葫Ȃ΃[vB
			if (data.Length < hash.Length) {
				for (int i = 0; i < hash.Length; i++) {
					data[i % data.Length] ^= hash[i];
				}
			} else {
				for (int i = 0; i < data.Length; i++) {
					data[i] = hash[i % hash.Length];
				}
			}
			return data;
		}
	}
}
