using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Info = Toolkit.Updater.Info;

namespace UpdateInfoEditor {
	public partial class EntryConfigForm : Form {
		Info.Entry config;

		public Info.Entry Config {
			get { return config; }
		}

		public EntryConfigForm(Info.Entry v) {
			InitializeComponent();

			config = v.Clone();

			textBox1.Text = config.Source;
			textBox2.Text = config.Destination;
			checkBox1.Checked = config.Backup;
			checkBox2.Checked = config.Obsoleted;
		}

		private void buttonOk_Click(object sender, EventArgs e) {
			config.Source = textBox1.Text;
			config.Destination = textBox2.Text;
			config.Backup = checkBox1.Checked;
			config.Obsoleted = checkBox2.Checked;
		}
	}
}