﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ふせん {
	public class Data : Toolkit.Serializable {
		public List<TagData> TagDataList = new List<TagData>();
		public long WindowHandle = 0; // ←IntPtrはシリアライズ出来ないらしい

		public Toolkit.Updater.Data.UpdateRecord UpdateRecord = new Toolkit.Updater.Data.UpdateRecord();

		#region Serialize/Deserialize

		/// <summary>
		/// 書き込み
		/// </summary>
		public void Serialize() {
			Serialize(".dat");
		}

		/// <summary>
		/// 読み込み
		/// </summary>
		public static Data Deserialize() {
			try {
				return Deserialize<Data>(".dat");
			} catch {
				return new Data();
			}
		}

		#endregion
	}
}
