using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace CommonArchiverLibrary.Win32
{
    internal static class NativeMethods
    {
        //DLLW[}bv
        [DllImport("kernel32",
            EntryPoint = "LoadLibrary",
            SetLastError = true,
            CharSet = CharSet.Auto,
            ExactSpelling = false)]
        public extern static IntPtr LoadLibrary(
            [MarshalAs(UnmanagedType.LPTStr)]string lpFileName);
        //DLLW[̎QƃJEg1炷
        [DllImport("kernel32",
            EntryPoint = "FreeLibrary",
            SetLastError = true,
            ExactSpelling = true)]
        public extern static bool FreeLibrary(
            IntPtr hModule);
        //֐̃AhX擾
        [DllImport("kernel32",
            EntryPoint = "GetProcAddress",
            SetLastError = true,
            CharSet = CharSet.Ansi,
            ExactSpelling = true)]
        public extern static IntPtr GetProcAddress(
            IntPtr hModule,
            [MarshalAs(UnmanagedType.LPStr)]string lpProcName);

        //t@C
        [DllImport("kernel32",
            EntryPoint = "SearchPath",
            SetLastError = true,
            CharSet = CharSet.Auto,
            ExactSpelling = false)]
        public static extern uint SearchPath(
            [MarshalAs(UnmanagedType.LPTStr)]string lpPath,
            [MarshalAs(UnmanagedType.LPTStr)]string lpFileName,
            [MarshalAs(UnmanagedType.LPTStr)]string lpExtension,
            uint nBufferLength,
            [MarshalAs(UnmanagedType.LPTStr)]StringBuilder lpBuffer,
            out IntPtr lpFilePart);
    }
}
