using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Toolkit.Forms {
	/// <summary>
	/// ̃WI{^܂Ƃ߂Ĉ߂̃NXB
	/// </summary>
	public class Radios {
		RadioButton[] radios;

		/// <summary>
		/// WI{^쐬B
		/// </summary>
		public Radios(params RadioButton[] radios) {
			this.radios = radios;
		}

		/// <summary>
		/// GroupBoxPanelȂǂ쐬B
		/// X^uI[_[ɂȂ񂾂Ǝv
		/// Ô߃^uI[_[ŖIɃ\[ĝŃ^uI[_[ɒӁB
		/// </summary>
		/// <param name="parent">RadioButtonplȂ</param>
		/// <param name="radioCount">RadioButton̐BAssert()邾B</param>
		public Radios(Control parent, int radioCount) {
			List<RadioButton> list = new List<RadioButton>();
			// WI{^(čċA͂ɂPKw)T
			foreach (Control c in parent.Controls) {
				RadioButton r = c as RadioButton;
				if (r != null) {
					list.Add(r);
				}
			}
			System.Diagnostics.Debug.Assert(list.Count == radioCount);
			// ^uI[_[Ń\[g
			list.Sort(delegate(RadioButton a, RadioButton b) {
				return a.TabIndex.CompareTo(b.TabIndex);
			});
			// o
			radios = list.ToArray();
		}

		/// <summary>
		/// l̎擾EݒB
		/// ̃NX̓R~߂̂́B
		/// </summary>
		public int Value {
			get {
				int n = -1;
				for (int i = 0; i < radios.Length; i++) {
					if (radios[i].Checked) {
						System.Diagnostics.Debug.Assert(n == -1);
						n = i;
					}
				}
				return n;
			}
			set {
				System.Diagnostics.Debug.Assert(0 <= value);
				System.Diagnostics.Debug.Assert(value < radios.Length);
				for (int i = 0; i < radios.Length; i++) {
					radios[i].Checked = i == value;
				}
			}
		}
	}
}
