using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Info = Toolkit.Updater.Info;

namespace UpdateInfoEditor {
	public partial class NoticeConfigForm : Form {
		Info.Notice config;

		public Info.Notice Config {
			get { return config; }
		}

		public NoticeConfigForm(Info.Notice v) {
			InitializeComponent();

			config = v.Clone();

			textBox1.Text = config.Text
				.Replace(Environment.NewLine, "\n")
				.Replace("\n", Environment.NewLine);
		}

		private void buttonOk_Click(object sender, EventArgs e) {
			config.Text = textBox1.Text
				.Replace(Environment.NewLine, "\n")
				.Replace("\n", Environment.NewLine);
		}
	}
}