﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace ふせん {
	[Serializable]
	public class TagData {
		public string FileName;
		public Point Location;

		public TagData() { }

		public TagData(string fileName) {
			FileName = fileName;
			Rectangle rc = System.Windows.Forms.Screen.PrimaryScreen.WorkingArea;
			Location = new Point(rc.Width / 2 - 30, rc.Height / 2 - 30);
				// ↑とりあえず真ん中あたりに表示する。別に厳密である必要はないので適当に。
		}
	}
}
